part of masamune_agora;

class AgoraStreamingAdapter extends StreamingAdapter<AgoraRTCChannelModel> {
  const AgoraStreamingAdapter({
    this.appId,
    this.userName,
    this.customerId,
    this.customerSecret,
    this.storageBucketConfig,
  });

  final String? appId;
  final String? userName;
  final String? customerId;
  final String? customerSecret;
  final StorageBucketConfig? storageBucketConfig;

  @override
  Future<void> initialize() {
    return AgoraRTCCore.initialize(
      appId: appId!,
      userName: userName!,
      customerId: customerId,
      customerSecret: customerSecret,
      storageBucketConfig: storageBucketConfig as AgoraStorageBucketConfig?,
    );
  }

  @override
  ChangeNotifierProvider<AgoraRTCChannelModel> modelProvider(String path) {
    return agoraRTCChannelModel(path);
  }

  @override
  AgoraStreamingAdapter? fromMap(DynamicMap map) {
    return AgoraStreamingAdapter(
      appId: map.get("appId", ""),
      userName: map.get("userName", ""),
      customerId: map.get("customerId", ""),
      customerSecret: map.get("customerSecret", ""),
      storageBucketConfig: map.getAsMap("storageBucketConfig",
          <String, dynamic>{})._toAgoraStorageBucketConfig(),
    );
  }

  @override
  DynamicMap toMap() {
    return <String, dynamic>{
      if (appId.isNotEmpty) "appId": appId,
      if (userName.isNotEmpty) "userName": userName,
      if (customerId.isNotEmpty) "customerId": customerId,
      if (customerSecret.isNotEmpty) "customerSecret": customerSecret,
      if (storageBucketConfig != null)
        "storageBucketConfig": storageBucketConfig!.toMap(),
    };
  }
}
